# Class HTMLUtils

java.lang.Object
com.codename1.ui.html.HTMLUtils

public final class HTMLUtils extends Object
This class contains several useful static methods for HTML

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static String`
  `convertCharEntity(String charEntity, boolean lookupHTMLentities, Hashtable userDefinedCharEntities)`
  Converts a char entity to the matching character or string.
  `static String`
  `convertHTMLCharEntity(String charEntity)`
  Converts an HTML char entity to the matching character or string.
  `static String`
  `convertXMLCharEntity(String charEntity)`
  Converts an XML char entity to the matching character or string.
  `static String`
  `encodeString(String str)`
  Encodes the specified string to "percent-encoding" or URL encoding.

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `final Class`
  `getClass()`
  Returns the runtime class of an object.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes current thread to wait until another thread invokes the method or the method for this object.
  `final void`
  `wait(long timeout)`
  Causes current thread to wait until either another thread invokes the method or the method for this object, or a specified amount of time has elapsed.
  `final void`
  `wait(long timeout, int nanos)`
  Causes current thread to wait until another thread invokes the method or the method for this object, or some other thread interrupts the current thread, or a certain amount of real time has elapsed.

- ## Method Details

  - ### convertXMLCharEntity

    public static String convertXMLCharEntity(String charEntity)

    Converts an XML char entity to the matching character or string. This is a convenience method that uses convertCharEntity with false for lookupHTMLentities and a null userDefinedCharEntities

    ###### Parameters

    - `charEntity`: The char entity to convert (Not including the & and ;)

    ###### Returns

    A string containing a single char, or the original char entity string (with & and ;) if the char entity couldn't be resolved

  - ### convertHTMLCharEntity

    public static String convertHTMLCharEntity(String charEntity)

    Converts an HTML char entity to the matching character or string. This is a convenience method that uses convertCharEntity with true for lookupHTMLentities and a null userDefinedCharEntities

    ###### Parameters

    - `charEntity`: The char entity to convert (Not including the & and ;)

    ###### Returns

    A string containing a single char, or the original char entity string (with & and ;) if the char entity couldn't be resolved

  - ### convertCharEntity

    public static String convertCharEntity(String charEntity, boolean lookupHTMLentities, Hashtable userDefinedCharEntities)

    Converts a char entity to the matching character or string. This handles both numbered and symbol char entities (The latter is done via getCharEntityCode)

    ###### Parameters

    - `charEntity`: The char entity to convert (Not including the & and ;)

    - `lookupHTMLentities`: true to include the basic HTML named char entities (unicode 160-255), false otherwise

    - `userDefinedCharEntities`: A hashtable containing (String,int) dentoing the char entity name and its unicode

    ###### Returns

    A string containing a single char, or the original char entity string (with & and ;) if the char entity couldn't be resolved

  - ### encodeString

    public static String encodeString(String str)

    Encodes the specified string to "percent-encoding" or URL encoding. This encodes reserved, unsafe and unicode characters

    ###### Parameters

    - `str`: The string to be encoded

    ###### Returns

    A percent-encoding of the string (safe characters remain the same)